#!/usr/bin/perl -w
#
# This code is distributed under the terms of the GPL
#
# (c) Scott Knight 2004
# scott@scottknight.com

package SRK::BMM::Modem;

use strict;

my $VERSION = 0.3;

my $debug = 0;
my $params;
my $data;

my $ret = 1;
my $modem;

sub new {
	my ($class) = @_;
	my $self = {
		_getData	=>	undef
	};
	bless $self, $class;

	$params = $_[1];
	$data = $_[2];

	if (defined $params->{'debug'}) { $debug = $params->{'debug'} };
	printDebug(1, "VERSION $VERSION");
	printDebug(2, "new() starting");

	printDebug(2, "Getting model: $params->{'model'}");
	my $model = $params->{'model'};

	### Code that I wrote
	$params->{'modem_found'} = 1;
	eval "require SRK::BMM::Modem::CableModem::$model";
	if ($@) {
		printDebug(1, "Not a CableModem, trying DSLModem");
		eval "require SRK::BMM::Modem::DSLModem::$model";
		if ($@) {
			printDebug(1, "Not a DSLModem either, exiting");
			$params->{'modem_found'} = 0;
		}
	}
	if ($params->{'modem_found'}) {
		$modem = $model->new($params, $data);
	}

	### Code that OpenSourceror suggested
	#for (qw(SRK::BMM::Modem::CableModem SRK::BMM::Modem::DSLModem)) {
	#eval "require ${_}::$model";
	#unless ($@) { $modem = $model->new($params, $data); last; }
	#print "eval for $_ failed";
	#}

	### Code that Somni suggested
	#my $modem_class = load_modem("CableModem", $model) || load_modem("DSLModem", $model) || die("Unable to load modem class: $@");
	#$modem = $modem_class->new($params, $data);

	printDebug(2, "new() finished");
	return $self;
}

### Code that Somni suggested
#sub load_modem {
#my($class, $model) = @_;
#printDebug(1, "class: $class, model: $model");
#my $full_class = "SRK::BMM::Modem::$class\::$model";
#printDebug(1, "$full_class");
#eval "require $full_class";
#printDebug(3, "$@");
#return $@ ? undef : $full_class;
#}

sub getData {
	printDebug(2, "getData() starting");
	if ($ret) {
		$modem->getData();
	}
	printDebug(2, "getData() finished");
}

sub printDebug {
	if ($debug >= $_[0]) {
		printf "***Modem.pm*** $_[1]\n";
	}
}

1;
