#!/usr/bin/perl
#
# This code is distributed under the terms of the GPL
#
# (c) Scott Knight 2004
# scott@scottknight.com

package CableModem;

use strict;

my $VERSION = 0.1;

my $debug = 0;
#my $params;
#my $data;
#my $defaults;

my $modem_type = 'cable';

use SRK::BMM::Modem::GenericModem;
our @ISA = qw(GenericModem);

sub new {
	my ($class) = @_;

	my $params = $_[1];
	my $data = $_[2];
	my $defaults = $_[3];

	if (defined $params->{'debug'}) { $debug = $params->{'debug'} };
	printDebug(1, "VERSION $VERSION");
	printDebug(2, "new() starting");

	my $self = $class->SUPER::new($params, $data, $defaults);
	bless $self, $class;

	printDebug(1, "Setting parameter modem_type: '$modem_type'");
	$params->{'modem_type'} = $modem_type;

	printDebug(2, "new() finished");
	return $self;
}

sub printDebug {
	if ($debug >= $_[0]) {
		printf "***CableModem.pm*** $_[1]\n";
	}
}

1;
