#!/usr/bin/perl
#
# This code is distributed under the terms of the GPL
#
# (c) Scott Knight 2004
# scott@scottknight.com

package GenericModem;

use strict;

my $VERSION = 0.1;

my $debug = 0;
#my $params;
#my $data;

sub new {
	my ($class) = @_;
	my $self = {
		_getData	=>	undef,
		_validateNumber	=>	undef
	};
	bless $self, $class;

	my $params = $_[1];
	my $data = $_[2];
	my $defaults = $_[3];

	if (defined $params->{'debug'}) { $debug = $params->{'debug'} };
	printDebug(1, "VERSION $VERSION");
	printDebug(2, "new() starting");

	foreach my $key(sort keys %$defaults) {
		unless (exists $params->{$key}) {
			printDebug(1, "Setting parameters $key: '$defaults->{$key}' (default)");
			$params->{$key} = $defaults->{$key};
		}
	}

	printDebug(2, "new() finished");
	return $self;
}

sub getData {
	printDebug(2, "getData() starting");
	printDebug(1, "getData() is an empty prototype method");
	printDebug(2, "getData() finished");
	return 1;
}

sub validateNumber {
	printDebug(2, "validateNumber() starting");

	my $self = shift;
	my $potential_number = $_[0];

	my $ret = 1;

	if ($potential_number =~ /^([+-]?)(?=\d|\.\d)\d*(\.\d*)?$/) {
		printDebug(2, "A number: '$potential_number'");
	}
	else {
		printDebug(2, "Not a number: '$potential_number'");
		$ret = 0;
	}

	printDebug(2, "validateNumber() finished");
	return $ret;
}

sub printDebug {
	if ($debug >= $_[0]) {
		printf "***GenericModem.pm*** $_[1]\n";
	}
}

1;
