#!/usr/bin/perl
#
# coded by Scott Knight 2004
# scott@scottknight.com
#
# This code is distributed under the terms of the GPL

package SRK::SMTP;

use strict;

my $VERSION = 0.1;

my $debug = 0;
my $params;

my $eol = "\015\012";

my $init_done = 0;

sub new {
	my ($class) = @_;
	my $self = {
		_send	=>	undef
	};
	bless $self, $class;

	$params = $_[1];

	if (defined $params->{'debug'}) { $debug = $params->{'debug'} };
	printDebug(1, "VERSION $VERSION");
	printDebug(2, 'new() starting');

	printDebug(1, "email_from: ".$params->{'email_from'});
	printDebug(1, "email_to: ".$params->{'email_to'});
	printDebug(1, "email_subject: ".$params->{'email_subject'});
	printDebug(1, "email_server: ".$params->{'email_server'});
	#printDebug(1, "email_username: ".$params->{'email_username'});
	#printDebug(1, "email_password: ".$params->{'email_password'});
	#printDebug(1, "email_port: ".$params->{'email_port'});

	if ($params->{'email_from'} eq "") {
		printDebug(0, "The email_from variable is empty. Exiting.");
	}
	elsif ($params->{'email_to'} eq "") {
		printDebug(0, "The email_to variable is empty. Exiting.");
	}
	elsif ($params->{'email_subject'} eq "") {
		printDebug(0, "The email_subject variable is empty. Exiting.");
	}
	elsif ($params->{'email_server'} eq "") {
		printDebug(0, "The email_server variable is empty. Exiting.");
	}
	else {
		$init_done = 1;
	}

	printDebug(2, 'new() finished');
	return $self;
}

sub send {
	printDebug(2, 'send() starting');
	my $email_body = $_[1];

	my $msg = "";
	$msg = $msg."X-Mailer: Perl".$eol;
	$msg = $msg."To: ".$params->{'email_to'}.$eol;
	$msg = $msg."From: ".$params->{'email_from'}.$eol;
	$msg = $msg."Subject: ".$params->{'email_subject'}.$eol;
	$msg = $msg.$eol;
	
	foreach my $line(@$email_body) {
		$msg = $msg.$line;
	}

	printDebug(1, "Loading Net::SMTP module");
	use Net::SMTP;

	printDebug(1, "Instantiating Net::SMTP");
	my $smtp = Net::SMTP->new($params->{'email_server'});
	die "Couldn't connect to server" unless $smtp;

	$smtp->mail( $params->{'email_from'} );
	$smtp->to( $params->{'email_to'} );

	# This does not work without adding a library to SmoothWall Express 2.0
	#$smtp->auth( $email_username, $email_password );

	printDebug(1, "Sending message");
	printDebug(2, "");
	printDebug(2, "---message begin---");

	if ($debug >= 2) { printf $msg; }
	$smtp->data();

	printDebug(2, "---message end---");
	printDebug(2, "");

	#$smtp->datasend("X-Mailer: Perl$eol");
	#$smtp->datasend("To: ".$params->{'email_to'}.$eol);
	#$smtp->datasend("From: ".$params->{'email_from'}.$eol);
	#$smtp->datasend("Subject: ".$params->{'email_subject'}.$eol);
	#$smtp->datasend($eol);
	
	#foreach my $line(@email_body) {
	#$smtp->datasend($line);
	#}

	$smtp->datasend($msg);

	$smtp->dataend();
	$smtp->quit();

	printDebug(0, "Email sent to ".$params->{'email_to'});
	printDebug(2, 'send() finished');

	return 1;
}

sub printDebug {
	if ($debug >= $_[0]) {
		printf "***SMTP.pm*** $_[1]\n";
	}
}

1;
